//+------------------------------------------------------------------+
//|                                                   Edem_Index.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
//---- input parameters
extern int       Periods=8;
//---- buffers
double ExtMapBuffer1[]; 
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1); 
   
    
 //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }  

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+ 


int start()
  {
   int    counted_bars = IndicatorCounted();   
   
   //---- check for possible errors
   if (counted_bars < 0) return(-1); 
        
   //---- last counted bar will be recounted
   if (counted_bars > 0) counted_bars--;
   
   int pos = Bars - counted_bars;
   int limit = pos; 
   
   
     
   Comment("My indicator is on the main chart windows!"); 
   
   
   //Prepare to two arrays used to compute the averages for Range and Open - Close
   double range_buffer[];
   double open_close_buffer[];

     
   ArrayResize(open_close_buffer, pos);            //resize the array to the number of bars
   ArraySetAsSeries(open_close_buffer,true);       //reverse the array direction.
   
   ArrayResize(range_buffer, pos);             //resize the array to the number of bars
   ArraySetAsSeries(range_buffer,true);        //reverse the array direction.
   
      
   int counter;
   
   for (counter = 0; counter < pos; counter++)
      {
        open_close_buffer[counter] = getOpen(counter)- getClose(counter); 
        range_buffer[counter] = getRange(counter);
      }
   
       
   //---- main calculation loop    
   for (counter = 0; counter < pos; counter++)
      { 
          ExtMapBuffer1[counter] = getProxyValue(getAvg(open_close_buffer, limit, Periods, counter), getAvg(range_buffer, limit, Periods, counter));
      }  
      
   return(0);
  }  
  


double getRange(int shift)
   {
      return (getHigh(shift) - getLow(shift));
   }  
   
double getHigh(int shift)
   {
      return (High[shift]);
   }  
   
double getLow(int shift)
   {
      return (Low[shift]);
   }  
   
double getOpen(int shift)
   {
      return (Open[shift]);
   }  
   
   
double getClose(int shift)
   {
      return (Close[shift]);
   } 
   
   
double getProxyValue(double numerator, double denumerator)
   {
      double res; 
      
      if (denumerator == 0) 
        {  
          res = 50;        
        } 
      else 
        res = ((numerator / denumerator) * 50) + 50 ;
     
      return (res);
   } 

double getAvg(double array[], int total, int period, int shift)
   {
      return (iMAOnArray(array, total, period, 0, MODE_SMA, shift));    
   } 

//+------------------------------------------------------------------+